# *************************************************************** #
#               Copyright © Hero Imaging AB 2022. 				  #
#  					  All Rights Reserved.						  #
# *************************************************************** #

from __future__ import annotations
from typing import Callable, Any, Optional
from heropytools.Serialization.Attributes import Attributes
from heropytools.Serialization.CustomSerializer import CustomSerializer

from abc import ABC
from uuid import uuid4


class IODescription(ABC):

    def __init__(self, id_str: str):
        if id_str is None:
            self._id = str(uuid4())
        else:
            self._id = id_str

    
    def __eq__(self, other):
        return self._id == other._id

    def get_container_id(self):
        pass

    # --- Autogenerated --- #

    # Name of the type.
    _type_str = "IODescription"

    # Datatype attributes.
    _attributes = Attributes("IODescription", version=0, member_count=1)

    # Serialization.
    def serialize(self, writer_fun: Callable[[Any, str, str, Optional[CustomSerializer]], None]):
        writer_fun(self._id, "String", "ID", None)

    # Deserialization.
    @staticmethod
    def deserialize(reader_fun: Callable[[str, Optional[CustomSerializer]], Any]):
        data = dict()
        data["_id"], _ = reader_fun("String", None)
        return data
